

<h1 align="center" > Ilse Langnar's Notebook </h1>
<h2 align="center" > Memoirs of a Recon Corps Member </h2>

<p align="center">
  <img src="https://github.com/ilse-langnar/notebook/blob/dev/markdown/ilse.jpeg" alt="Ilse"/>
</p>
<br/>


<h4 align="center" > Ilse Langnar's Notebook is a free, knowledge management platform. </h4>
<br/>


Imagine [Roam Research](https://roamresearch.com/) + [Obsidian](https://obsidian.md/) + [Anki](https://ankiweb.net/) + [Supermemo](https://www.supermemopedia.com/wiki/Main_Page) but without their downsides such as online-only, lock-in, bad algorithm, complexity etc.

Ilse aims to be the ultimate study and note-taking tool by learning from its predecessors and building something that last by implementing a standard instead of building just software which might [rot overtime]( https://en.wikipedia.org/wiki/Software_rot).

Try the online [Demo](https://ilse-langnar.github.io/notebook/demo/index.html) or download it form [Linux](https://github.com/ilse-langnar/notebook/releases/download/0.8/ilse-langnar-notebook-0.1.8.AppImage) [Windows](https://github.com/ilse-langnar/notebook/releases/download/0.8/ilse-langnar-notebook-0.1.8.AppImage) or [OS x]().

If anything goes wrong, please open a [Issue](https://github.com/ilse-langnar/notebook/issues/new).

## Why
To augment human cognition with memory, references and more.
Ilse is based on the Apex Cerebrum Framework: https://ilse-langnar.github.io/notebook/apex-cerebrum.html
We avoid any type of lock-in due to the fact that a simple set of files and folder is able to reproduce the entire system, which means that with a simple standardized format can be visualized in multiple ways like: __Mind Maps__, __Tree__, __Infinite Canvas__, __Spreadsheet__, and more.
And given that the format is standardized, if someone finds a new way of reprensenting data, we would simply have to write a plugin that representes those already standardized into the desired new format(presentation).
This way we avoid anye sort of proprietary binary format for organization and visualization, even if the software rots and dies, the files are still going to be there, the standard is still there, so you can, for example, implement a command line spreadsheet that can be visualized in a cloud client, a Web Browser, a Callphone, a toaster ... you get it.
This started with frustration not only with lock-in but the lack of extensability and standardazation of previous solutions.

## How

| Platform         | How     | Gif |
|--------------|-----------|------------|
| Web Demo | [Check](https://ilse-langnar.github.io/notebook/demo/index.html) | Learn More | 
| Quine(Single .html) | [Download](https://github.com/ilse-langnar/notebook/releases/download/1.1.2/index.html) | Learn More | |
| Web(.html) | [Download](https://github.com/ilse-langnar/notebook/releases/download/1.1.2/html.1.0.11.tar.gz) | Learn More | |
| Desktop Linux(AppImage)           | [Download](https://github.com/ilse-langnar/notebook/releases/download/1.1.2/ilse-langnar-notebook-1.0.11.AppImage) | ![Demo](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/desktop-linux.gif) | 
| Desktop Windows(.exe)             | [Download](https://github.com/ilse-langnar/notebook/releases/download/1.1.2/ilse-langnar-notebook.Setup.1.0.11.exe) | 
| Desktop MacOs(.dmg)               | Comming Soon |
| Mobile Android(.apk)              | Comming Soon | 
| Mobile iOS                        | Comming Soon | 
| Command Line(nodejs)              | `npx ilse` & `npm install ilse -g` & `yarn add global ilse` | 
| Command Line(lisp, binary)        | Commind Soon | 
| Command Line(C/C++/Rust, binary)  | Commind Soon? | 
| Script  Windows(VB)               | Comming Soon | 
| Script Linux(Rofi)                | Comming Soon | ![Incremental Video](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/rofi.gif) |
| Script Linux(Zenity)              | Comming Soon| 
| Script MacOS(Rofi)                | Comming Soon | ![Incremental Video](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/rofi.gif) 
| Vim Plugin                | Help! | 
| VSCode Plugin                | Help! | 
| Emacs Plugin                | Help! | 
| Sublime Text Plugin                | Help! | 
| Headless Ilse(Docker)                | Comming Soon| 
| Telegram Bot           | Comming Soon| 




## Improves on:
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/improves-on.png"  />

## Features
| Feature         | Explanation     | Visual |
|--------------|-----------|------------|
| Dark Mode              | You can have different styles and they can have a light and a dark mode, if you download a theme, you can toggle dark mode with `C-SPC d d` or executing the "toggle-dark-mode" command | ![Dark Mode](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-dark-mode.gif) | 
| Zen Mode                | Allows you to focus on a single component and forget about anything else. | ![Zen Mode](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-zen-mode.gif) | 
| Themes                | You can have multiple themes and switch between them as you like. | ![Themes](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-themes.gif) | 
| Easy Import/Export    | You can import a theme or a plugin with a single click.  | ![Easy Import/Export](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-easy-import-and-export.gif) | |
| Multi Language Support | Ilse supports many different language.  | ![Multi Language](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-multi-language.gif) |
| Note Reference | You can embed a note inside another note.  | ![Note Embed](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-note-embed.gif) |
| File Reference | Reference files inside notes.  | ![File Embed](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-file-embed.gif) |
| Multiple Components | You can check a file while looking at the calendar and your daily notes.  | ![Multiple Components](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-multiple-components.gif) |
| Graph | Visualize relationship between notes, files, media and more.  | ![Graph](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-graph.gif) |
| Keyboard Shortcut | Bind shortcuts from simple such as `ctrl+s` to complex such as `ctrl+space i z`  | | ![Keyboard Shortcuts](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-shortcuts.gif) | 
| Commands and Command Pallet | See all the available commands with the command pallet, execute any function with commands  | ![Command Pallet](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-command-pallet.gif) | 
| Study Tools | See "Studying with Ilse" for more | ![Study](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-study.gif) |
| Daily Notes | This is your hub, this is where you start off if you're confused as to where to go. | ![Daily Notes](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-daily-notes.gif) |
| Multiple Directories | You can have as many directories as you want, maybe something for work, something for study etc. | |
| CRM | Keep track of in Ilse | |
| Task Manager | Manage all of your todos in one single place. | ![Task Management](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-task-management.gif) | |
| Media Embed | Embed images, videos, sounds, gifs and more. | ![Media Embed](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-media-embed.gif) |
| Component Embed | Embed kanban, calendar, spreadsheets, Todos, reminders, help, tutorials, Mind Maps, Memex, Files and more inside a note. | ![Component Embed](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-component-embed.gif) |
| Platform Independent | You can use it on Windows, Linux, MacOS, BDS??, Android, iOS etc. You can also develop a client for a platform if we don't support it. | |
| Plain Text & No Lock-In| We don't store anything in proprietary binary format, thus if we ever were to "die" you would still have your notes and your files. Since it's a simple text/files structure that will live for a thousand years. | |
| Free and Open Source | I would appreciate if you paid something but it's free and open source. | |
| Right/Left Sidebar |  You can put anything you want there with quick access | ![Right Sidebar](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/feature-right-sidebar.gif) | 
| Zettelkasten | We don't use directories and you have access to links to link a note to a file or to another note. | |
| Inline Embeds | You can use {{}} to embed things such as: Queries, todos, tags, word-count, timer and more! | |
| Drag & Drop | Drag and Drop either notes, media or other. | |



## Screenshots
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-15.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-16.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-17.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-2.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-13.png" />
<img src="https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/ilse-screenshot-14.png" />

## Use Cases
As a Note-Taking tool: 
As a Study(memory) tool:
As a App Factory tool: 


## Studying with Ilse
| What         | Explanation     | Visual |
|--------------|-----------|------------|
| Incremental Learning | See: Incremental Reading & Incremental Video | | 
| Incremental Reading | TODO | ![Incremental Reading](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/incremental-reading.svg) | 
| Incremental Video | TODO | ![Incremental Video](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/incremental-video.svg) | 
| Spaced Repetition | TODO | ![Spaced Repetition - Forgetting Curve](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/forgetting-curve.jpg) | 
| Interleaving | TODO | | 
| Testing |  TODO | | 
| Creation |  TODO | | 
| Ellaboration | TODO | | 

### Example 1 - Chemistry
| Step         | Explanation     | Visual |
|--------------|-----------|------------|
| 1 | You import a wikipedia article on: Alcohol, and you see a table with a bunch of alcohols and how to name them: | ![Alcohols](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/all-alcohols.png) |
| 2 | You take screenshot of the first alcohol | ![First Alcohol](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/alcohol.png) |
| 3 | You take screenshot of the second alcohol | ![Second Alcohol](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/alcohol-1.png) |
| 4 | You take screenshot of the third alcohol | ![Third Alcohol](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/alcohol-2.png) |
| 5 | You take screenshot of the Fourth alcohol | ![Fourth Alcohol](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/alcohol-3.png) |
| 6 | After taking a screenshot of each item, each one of them will be "queued" differently based on your memory, thus the schedule for each item will be different based on how well you remember the alcohol, allowing you to "chunk" this knowledge about alcohols | |

### Example 2 - TODO


## One data, many forms
| Data Format         | Explanation     | Visual |
|--------------|-----------|------------|
|  Spreadsheet | TODO |  ![Spreadsheet](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/spreadsheet-light-mode.png) ![Spreadhseet](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/spreadsheet-dark-mode.png) |
|  Memex | TODO  |  ![Memex](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/memex.png) |
|  Calendar | TODO  |  ![Calendar](https://raw.githubusercontent.com/ilse-langnar/notebook/dev/docs/calendar.png) |
|  Kanban | TODO  |  |
|  Xanadu | Comming Soon ...  | |


## Ways of Contributing
| Way         | Explanation     | Value |
|--------------|-----------|------------|
| Opening an issue    | If you have a question or something is wrong, you can [open a issue](https://github.com/ilse-langnar/notebook/issues/new)  so we can figure itt out. | Medium |
| Help with translation | You can help translate ilse into another language such as: `Chinese Simplified(简体中文) Brazillian Portuguese(Português Brasileiro) Spanish(Español) Korean(한국어) japanese(日本人) Dutch(Nederlands) Hebrew (עברית) French (français) Italian (italiano) Greek (Ελληνικά) Arabic (عربى) Russian (русский) Polish (Polskie) German(Deutsche)` go to [Here](https://github.com/ilse-langnar/notebook/issues/new) edit the file with the ISO code for the language, translate it, then add push so I can add it the `dev` branch and then to a more stable branch. | Medium |
| Donate Money| I'll work much harder and focused if I don't have to worry about my expenses thus making the project progress at a much faster rate. | High |
| Become a tester |  If you have a "niche" device please join as a tester to test the stability in different platforms(Blackberry, BDS?, MacOS, Linux Distros, Older Windows ). | High |
| Make a `command` |  A command is a executable piece of code encapsulated into a name, they're very good for speed! | Low |
| Make a `CSS Snippet` | CSS snippets fix little style errores where a full theme would be unecessary, use: "#i/css \`\`\`css html, body { background: red; }\`\`\`. | Low |
| Make a `Theme` |  A theme is like a bunch of css snippets but they relate to each other to form a more "grand" structure, use this template to create themes:  [Theme Template](https://github.com/ilse-langnar/theme-template). | Medium |
| Make a `Plugin` |  A plugin is where you actually extend ilse with more components, commands and functionality, make plugins using:  [Plugin Template](https://github.com/ilse-langnar/plugin-template). | High |
| Make a `Blog/Article/Video` | Create something documenting how you use ilse in your life, I'll greatly appreciate it!. | Medium |
| Make `Flashcards`  | Create a project with the sturcture like: [Flashcards Template](https://github.com/ilse-langnar/flashcards-template). and fill it with your item. | Medium |
| Make Memes | Help spread the tool with virality and easy-to-consume memes. | High |
| Join Discord | I'll post updates, ideas, plugins, themes, snippets, commands screenshots and more. https://discord.gg/9BVx8YHr | Medium |
| Fix a bug yourself | Modify the code and then do a push into the `dev` branch, I'll later move it to more stable branches. | High |
| Become smarter| That's the final goal here, the final goal is better thinking. | Inifinity |


<br>
